event_organizer/account/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('',views.query_account,name='account'),
    path('create',views.CreateAccount.as_view(),name='create_account'),
    path('<int:pk>',views.detail_account,name='detail_account'),
    path('<int:pk>/update',views.UpdateAccount.as_view(),name='update_account'),
    path('<int:pk>/delete',views.DeleteAccount.as_view(),name='delete_account'),
]

event_organizer/event/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('',views.event,name='event'),
    path('create',views.CreateEvent.as_view(),name='create_event'),
    path('<int:pk>',views.detail_event,name='detail_event'),
    path('<int:pk>/update',views.UpdateEvent.as_view(),name='update_event'),
    path('<int:pk>/delete',views.DeleteEvent.as_view(),name='delete_event'),
]

event_organizer/event_organizer/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static
from django.conf import settings
from django.contrib.auth.views import LoginView, LogoutView
from event.views import event

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', event,name='home'),
    path('login',LoginView.as_view(template_name='login.html'),name='login'),
    path('logout',LogoutView.as_view(),name='logout'),
    path('event/',include('event.urls')),
    path('account/',include('account.urls')),
]+static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

event_organizer/account/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class Account(models.Model):
    """
    This is account model. This model is and extended model of django User model.
    """
    user = models.OneToOneField(User,on_delete=models.CASCADE)
    phone = models.CharField(max_length=20,blank=True,null=True)
    profpic = models.ImageField(blank=True,null=True,upload_to='profpic')

    def get_events(self):
        """
        Get event involved for current account.
        Return
        ---------
        Queryset object
        """
        from event.models import EventInvolved
        records = EventInvolved.objects.select_related('event').filter(participant=self)
        return records

event_organizer/event/models.py
from django.db import models

# Create your models here.
class Event(models.Model):
    name = models.CharField(max_length=150)
    shortname = models.CharField(max_length=15,blank=True,null=True)
    start = models.DateTimeField()
    end = models.DateTimeField(blank=True,null=True)
    description = models.TextField(max_length=1000, blank=True,null=True)
    location = models.CharField(max_length=150,blank=True,null=True)
    preview = models.ImageField(blank=True,null=True,upload_to='preview')

    def __str__(self):
        if self.shortname:
            return self.shortname
        else:
            return self.name

    def get_participants(self):
        """
        Get participants list for a record.
        """
        records = EventInvolved.objects.select_related('participant').filter(event=self)
        if records:
            return records
        else:
            return None


class EventInvolved(models.Model):
    event = models.ForeignKey('event',on_delete=models.CASCADE)
    participant = models.ForeignKey('account.account',on_delete=models.SET_NULL,blank=True,null=True)

event_organizer/account/forms.py
from django import forms
from django.contrib.auth.models import User
from re import match

from .models import Account

class AccountForm(forms.ModelForm):
    username = forms.CharField(max_length=150)
    password = forms.CharField(max_length=150,required=False)
    password1 = forms.CharField(max_length=150,required=False,label='Password Confirmation')
    name = forms.CharField(max_length=150,required=False)

    class Meta:
        model = Account
        exclude = ['user'] 

    def __init__(self, *args, **kwargs):
        super().__init__(*args,**kwargs)
        if self.instance.pk:
            self.fields['username'].initial = self.instance.user.username
            self.fields['name'].initial = self.instance.user.first_name

    def is_changed(self,field,val):
        """
        Check wether a field is changed from current record. This function used in modelform.
        Parameters
        ---------
        field: str
            Name of field to be checked
        val: any
            Value of field to be checked
        """
        if self.instance.pk:
            prev_val = getattr(self.instance,field)
            return prev_val != val
        else:
            return True

    def clean_username(self):
        data = self.cleaned_data.get('username')
        user = User.objects.filter(username=username).first()
        if (self.instance.pk and self.instance.user.username != data and user) or (not self.instance.pk and user):
            self.add_error('username','Username with that name already exist.')
        return data

    def clean_phone(self):
        data = self.cleaned_data.get('phone')
        if self.is_changed('phone',data):
            if data and not data.is_numeric():
                self.add_error('',f'{data} is not valid phone number. Only number input is allowed.')
        return data

    def clean(self):
        if any(self.errors):
            return
        password = self.cleaned_data.get('password')
        password1 = self.cleaned_data.get('password1')
        if password and not password1 or not password and password1:
            self.add_error('','Both password field must be filled.')
        elif password and password1 and password!=password1:
            self.add_error('','Password not match.')

    def save(self):
        if self.instance.pk:
            password = self.cleaned_data.get('password')
            username = self.cleaned_data.get('username')
            first_name = self.cleaned_data.get('name')
            user = self.instance.user
            user.username = username
            user.first_name = first_name
            if password:
                user.set_password(password)
            user.save()
            return super().save()
        else:
            account = super().save(commit=False)
            username = self.cleaned_data.get('username')
            password = self.cleaned_data.get('password')
            first_name = self.cleaned_data.get('name')
            user = User.objects.create_user(username,password=password,first_name=first_name)
            account.user = user
            account.save()
            return account

event_organizer/account/views.py
from django.shortcuts import render, redirect
from django.urls import reverse, reverse_lazy
from django.views.generic import CreateView,UpdateView,DeleteView
from django.contrib.auth.decorators import login_required, user_passes_test
from django.contrib.auth.mixins import LoginRequiredMixin, UserPassesTestMixin

from .models import Account
from .forms import AccountForm

# Create your views here.
def user_is_staff(user):
    if user.is_staff:
        return True
    else:
        return False

@login_required
@user_passes_test(user_is_staff)
def query_account(request):
    data = Account.objects.select_related('user').all()
    return render(request,'account_query.html',{'data':data})

@login_required
def detail_account(request,pk):
    if not request.user.is_staff and request.user.pk!=pk:
        return redirect('home')
    data = Account.objects.get(pk=pk)
    return render(request,'account_detail.html',{'data':data})

class CreateAccount(CreateView):
    form_class = AccountForm
    success_url = reverse_lazy('account')
    template_name = 'account_form.html'


class UpdateAccount(LoginRequiredMixin,UserPassesTestMixin,UpdateView):
    model = Account
    form_class = AccountForm
    context_object_name = 'data'
    template_name = 'account_form.html'

    def get_success_url(self):
        return reverse('detail_account',kwargs={'pk':self.object.pk})

    def test_func(self):
        data = self.get_object()
        if not user_is_staff(self.request.user) and data.user.pk != self.request.pk:
            return False
        else:
            return True


class DeleteAccount(LoginRequiredMixin,UserPassesTestMixin,DeleteView):
    model = Account
    template_name = 'account_delete.html'
    success_url = reverse_lazy('account')
    context_object_name = 'data'
    
    def test_func(self):
        data = self.get_object()
        if not user_is_staff(self.request.user) and data.user.pk != self.request.pk:
            return False
        else:
            return True

event_organizer/account/templates/account_delete.html
{% extends 'base.html' %}

{% block title %}
    Delete account {{data.user.username}}?
{% endblock %}

{% block content %}
    <form method="POST" novalidate>
        <h3>Are you sure you will delete this account?</h3>
        <a class="btn btn-success" href="{% url 'account' %}">Cancel</a>
        <button class="btn btn-danger" type="submit">Yes</button>
    </form>
{% endblock %}

event_organizer/account/templates/account_detail.html
{% extends 'base.html' %}

{% block title %}
    Account {{data.user.username}}
{% endblock %}

{% block content %}
    <div class="col">
        <a class="btn btn-warning" href="{% url 'update_account' data.pk %}">Edit</a>
        <a class="btn btn-danger" href="{% url 'delete_account' data.pk %}">Delete</a>
    </div>
    <div class="w-100"></div>
    <div class="card">
        {% if data.profpic %}
            <img class="card-img-top" src="{{data.profpic.url}}"/>
        {% endif %}
        <div class="card-body">
            <table class="table">
                <tbody>
                    <tr>
                        <td>Name</td><td>:</td><td>{{data.user.first_name}}</td>
                    </tr>
                    <tr>
                        <td>Phone</td><td>:</td><td>{{data.phone}}</td>
                    </tr>
                    <tr>
                        <td>Username</td><td>:</td><td>{{data}}</td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <div class="w-100"></div>
    <div class="col">
        {% if data.eventinvolved_set.all %}
            <table class="table table-bordered">
                <thead class="thead-dark">
                    <tr>
                        <th>No</th>
                        <th>Event Name</th>
                        <th>Start</th>
                    </tr>
                </thead>
                <tbody>
                    {% for item in data.get_events %}
                        <tr>
                            <td>{{forloop.counter}}</td>
                            <td><a href="{% url 'detail_event' item.event.pk %}">{{item.event.name}}</a></td>
                            <td>{{item.event.start}}</td>
                        </tr>
                    {% endfor %}
                </tbody>
            </table>
        {% else %}
            <h5>No events is joined</h5>
        {% endif %}
    </div>
{% endblock %}

event_organizer/account/templates/account_form.html
{% extends 'base.html' %}

{% block title %}
    Account Form
{% endblock %}

{% block style %}
    {{block.super}}
    {% include 'includes/form_generic_style.html' %}
{% endblock %}

{% block content %}
    <form method="POST" novalidate enctype="multipart/form-data">
        {% csrf_token %}
        {% include 'includes/form_generic.html' %}
        {% if form.instance.pk %}
            <a class="btn btn-primary" href="{% url 'detail_account' form.instance.pk %}">Cancel</a>
        {% endif %}
        <button class="btn btn-success">Submit</button>
    </form>
{% endblock %}

{% block script %}
    {{block.super}}
    {% include 'includes/form_generic_script.html' %}
{% endblock %}

event_organizer/account/templates/account_query.html
{% extends 'base.html' %}

{% block title %}
    Accounts
{% endblock %}

{% block content %}
<div>
    <a class="btn btn-success" href="{% url 'create_account' %}">Add Account</a>
</div>
    <table class="table table-bordered">
        <thead class="thead-dark">
            <tr>
                <th>No</th>
                <th>Name</th>
                <th>Phone</th>
                <th>Username</th>
                <th>#</th>
            </tr>
        </thead>
        <tbody>
            {% for item in data %}
            <tr>
                <td>{{forloop.counter}}</td>
                <td>{{item.user.first_name}}</td>
                <td>{{item.phone}}</td>
                <td>{{item.user.username}}</td>
                <td>
                    <a href="{% url 'detail_account' item.pk %}"><i class="fas fa-info-circle"></i></a>
                    <a href="{% url 'update_account' item.pk %}"><i class="fas fa-edit"></i></a>
                    <a href="{% url 'delete_account' item.pk %}"><i class="fas fa-ban"></i></a>
                </td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
{% endblock content %}